﻿/*
 * Last review by   : Yaser
 * Last review date : JUL-21-09
 */
using System;

namespace ERP.Business.DataTypes.Employee.Attendance.Vacations
{
    /// <summary>
    /// Leave
    /// </summary>
    [System.Runtime.Serialization.DataContract]
    [Serializable]
    [System.Runtime.Serialization.KnownType(typeof(Leave))]
    public class Leave : BaseTypes.BaseType
    {
        #region Properties

        /// <summary>
        /// Gets or sets the date.
        /// </summary>
        /// <value>The date.</value>
        [System.Runtime.Serialization.DataMember]
        public DateTime Date
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the start hour.
        /// </summary>
        /// <value>The start hour.</value>
        [System.Runtime.Serialization.DataMember]
        public DateTime StartHour
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the end hour.
        /// </summary>
        /// <value>The end hour.</value>
        [System.Runtime.Serialization.DataMember]
        public DateTime EndHour
        {
            get;
            set;
        }

        /// <summary>
        /// Gets the duration.
        /// </summary>
        /// <value>The duration.</value>
        [System.Runtime.Serialization.DataMember]
        public double Duration
        {
            get
            {
                return (StartHour - EndHour).TotalMinutes;
            }
        }

        /// <summary>
        /// Gets or sets the status.
        /// </summary>
        /// <value>The status.</value>
        [System.Runtime.Serialization.DataMember]
        public LeaveStatus Status
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the type.
        /// </summary>
        /// <value>The type.</value>
        [System.Runtime.Serialization.DataMember]
        public LeaveType Type
        {
            get;
            set;
        }

        #endregion

        #region <ethods

        /// <summary>
        /// Compares two objects and returns a value indicating whether one is less than, equal to, or greater than the other.
        /// </summary>
        /// <param name="x">The first object to compare.</param>
        /// <param name="y">The second object to compare.</param>
        /// <returns>
        /// A signed integer that indicates the relative values of <paramref name="x"/> and <paramref name="y"/>, as shown in the following table.Value Meaning Less than zero <paramref name="x"/> is less than <paramref name="y"/>. Zero <paramref name="x"/> equals <paramref name="y"/>. Greater than zero <paramref name="x"/> is greater than <paramref name="y"/>.
        /// </returns>
        /// <exception cref="T:System.ArgumentException">Neither <paramref name="x"/> nor <paramref name="y"/> implements the <see cref="T:System.IComparable"/> interface.-or- <paramref name="x"/> and <paramref name="y"/> are of different types and neither one can handle comparisons with the other. </exception>
        public override int Compare(object x, object y)
        {
            if (ERP.Framework.Components.Utilities.ComparingHelper.ComapringManager.CompareTypes(x, y))
                return ((Leave)x).Date.CompareTo(((Leave)y).Date);
            return -1;
        }

        #endregion
    }
}
