﻿/*
 * Last review by   : Yaser
 * Last review date : JUL-27-09
 */
using System;
using ERP.Business.DataTypes.Employee.Attendance;
using ERP.Business.DataTypes.Employee.Information;
using ERP.Business.DataTypes.Employee.Performance;
using ERP.Business.DataTypes.Employee.Salary;

namespace ERP.Business.DataTypes.Employee
{
    /// <summary>
    /// Employee
    /// </summary>
    [System.Runtime.Serialization.DataContract]
    [Serializable]
    [System.Runtime.Serialization.KnownType(typeof(Employee))]
    public class Employee : BaseTypes.BaseType
    {
        #region Properties

        /// <summary>
        /// Gets or sets the employment info.
        /// </summary>
        /// <value>The employment info.</value>
        [System.Runtime.Serialization.DataMember]
        public EmploymentInformation EmploymentInfo
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the name.
        /// </summary>
        /// <value>The name.</value>
        [System.Runtime.Serialization.DataMember]
        public string Name
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the contact info.
        /// </summary>
        /// <value>The contact info.</value>
        [System.Runtime.Serialization.DataMember]
        public ContactInformation ContactInfo
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the health info.
        /// </summary>
        /// <value>The health info.</value>
        [System.Runtime.Serialization.DataMember]
        public HealthInformation HealthInfo
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the official info.
        /// </summary>
        /// <value>The official info.</value>
        [System.Runtime.Serialization.DataMember]
        public OfficialInformation OfficialInfo
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the personal info.
        /// </summary>
        /// <value>The personal info.</value>
        [System.Runtime.Serialization.DataMember]
        public PersonalInformation PersonalInfo
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the CV info.
        /// </summary>
        /// <value>The CV info.</value>
        [System.Runtime.Serialization.DataMember]
        public CV.CVInformation CVInfo
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the job title.
        /// </summary>
        /// <value>The job title.</value>
        [System.Runtime.Serialization.DataMember]
        public Constants.JobTitle JobTitle
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the performance info.
        /// </summary>
        /// <value>The performance info.</value>
        [System.Runtime.Serialization.DataMember]
        public PerformanceInformation PerformanceInfo
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the salary info.
        /// </summary>
        /// <value>The salary info.</value>
        [System.Runtime.Serialization.DataMember]
        public SalaryInformation SalaryInfo
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the attendance info.
        /// </summary>
        /// <value>The attendance info.</value>
        [System.Runtime.Serialization.DataMember]
        public AttendanceInformation AttendanceInfo
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the user ID.
        /// </summary>
        /// <value>The user ID.</value>
        [System.Runtime.Serialization.DataMember]
        public string UserID
        {
            get;
            set;
        }

        #endregion

        #region Methods

        /// <summary>
        /// Compares two objects and returns a value indicating whether one is less than, equal to, or greater than the other.
        /// </summary>
        /// <param name="x">The first object to compare.</param>
        /// <param name="y">The second object to compare.</param>
        /// <returns>
        /// A signed integer that indicates the relative values of <paramref name="x"/> and <paramref name="y"/>, as shown in the following table.Value Meaning Less than zero <paramref name="x"/> is less than <paramref name="y"/>. Zero <paramref name="x"/> equals <paramref name="y"/>. Greater than zero <paramref name="x"/> is greater than <paramref name="y"/>.
        /// </returns>
        /// <exception cref="T:System.ArgumentException">Neither <paramref name="x"/> nor <paramref name="y"/> implements the <see cref="T:System.IComparable"/> interface.-or- <paramref name="x"/> and <paramref name="y"/> are of different types and neither one can handle comparisons with the other. </exception>
        public override int Compare(object x, object y)
        {
            if (ERP.Framework.Components.Utilities.ComparingHelper.ComapringManager.CompareTypes(x, y))
                return ((Employee)x).Name.CompareTo(((Employee)y).Name);
            return -1;
        }

        #endregion
    }
}
