﻿/*
 * Last review by   : Yaser
 * Last review date : JUL-21-09
 */
using System;

namespace ERP.Business.DataTypes.Employee.Information
{
    /// <summary>
    /// Contact Information
    /// </summary>
    [System.Runtime.Serialization.DataContract]
    [Serializable]
    [System.Runtime.Serialization.KnownType(typeof(ContactInformation))]
    public class ContactInformation : BaseTypes.BaseType
    {
        #region Properties

        /// <summary>
        /// Gets or sets the address.
        /// </summary>
        /// <value>The address.</value>
        [System.Runtime.Serialization.DataMember]
        public string Address
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the personal phone number.
        /// </summary>
        /// <value>The personal phone number.</value>
        [System.Runtime.Serialization.DataMember]
        public string PersonalPhoneNumber
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the mobile number.
        /// </summary>
        /// <value>The mobile number.</value>
        [System.Runtime.Serialization.DataMember]
        public string MobileNumber
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the personal email address.
        /// </summary>
        /// <value>The personal email address.</value>
        [System.Runtime.Serialization.DataMember]
        public string PersonalEmailAddress
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the official phone extension.
        /// </summary>
        /// <value>The official phone extension.</value>
        [System.Runtime.Serialization.DataMember]
        public string OfficialPhoneExtension
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the ZIP code.
        /// </summary>
        /// <value>The ZIP code.</value>
        [System.Runtime.Serialization.DataMember]
        public string ZIPCode
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the po box.
        /// </summary>
        /// <value>The po box.</value>
        [System.Runtime.Serialization.DataMember]
        public string PoBox
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the postal code.
        /// </summary>
        /// <value>The postal code.</value>
        [System.Runtime.Serialization.DataMember]
        public string PostalCode
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the state.
        /// </summary>
        /// <value>The state.</value>
        [System.Runtime.Serialization.DataMember]
        public string State
        {
            get;
            set;
        }

        #endregion
    }
}
