﻿/*
 * Last review by   : Yaser
 * Last review date : JUL-21-09
 */
using System;
using ERP.Business.DataTypes.Constants;

namespace ERP.Business.DataTypes.Employee.Information
{
    /// <summary>
    /// Personal Information
    /// </summary>
    [System.Runtime.Serialization.DataContract]
    [Serializable]
    [System.Runtime.Serialization.KnownType(typeof(PersonalInformation))]
    public class PersonalInformation : BaseTypes.BaseType
    {
        #region Properties

        /// <summary>
        /// Gets or sets the education level.
        /// </summary>
        /// <value>The education level.</value>
        [System.Runtime.Serialization.DataMember]
        public EducationLevel EducationLevel
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the birth date.
        /// </summary>
        /// <value>The birth date.</value>
        [System.Runtime.Serialization.DataMember]
        public DateTime BirthDate
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the gender.
        /// </summary>
        /// <value>The gender.</value>
        [System.Runtime.Serialization.DataMember]
        public Gender Gender
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the relegion.
        /// </summary>
        /// <value>The relegion.</value>
        [System.Runtime.Serialization.DataMember]
        public Constants.Relegion Relegion
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the name of the mother.
        /// </summary>
        /// <value>The name of the mother.</value>
        [System.Runtime.Serialization.DataMember]
        public string MotherName
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the place of birth.
        /// </summary>
        /// <value>The place of birth.</value>
        [System.Runtime.Serialization.DataMember]
        public string PlaceOfBirth
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the social status.
        /// </summary>
        /// <value>The social status.</value>
        [System.Runtime.Serialization.DataMember]
        public SocialStatus SocialStatus
        {
            get;
            set;
        }

        #endregion
    }
}
