﻿/*
 * Last review by   : Yaser
 * Last review date : JUL-21-09
 */
using System;

namespace ERP.Business.DataTypes.Employee.Salary
{
    /// <summary>
    /// Bonus
    /// </summary>
    [System.Runtime.Serialization.DataContract]
    [Serializable]
    [System.Runtime.Serialization.KnownType(typeof(Bonus))]
    public class Bonus : BaseTypes.BaseType
    {
        #region Properties

        /// <summary>
        /// Gets or sets the ammount.
        /// </summary>
        /// <value>The ammount.</value>
        [System.Runtime.Serialization.DataMember]
        public float Ammount
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the date.
        /// </summary>
        /// <value>The date.</value>
        [System.Runtime.Serialization.DataMember]
        public DateTime Date
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the notes.
        /// </summary>
        /// <value>The notes.</value>
        [System.Runtime.Serialization.DataMember]
        public string Notes
        {
            get;
            set;
        }

        #endregion

        #region Metods

        /// <summary>
        /// Compares two objects and returns a value indicating whether one is less than, equal to, or greater than the other.
        /// </summary>
        /// <param name="x">The first object to compare.</param>
        /// <param name="y">The second object to compare.</param>
        /// <returns>
        /// A signed integer that indicates the relative values of <paramref name="x"/> and <paramref name="y"/>, as shown in the following table.Value Meaning Less than zero <paramref name="x"/> is less than <paramref name="y"/>. Zero <paramref name="x"/> equals <paramref name="y"/>. Greater than zero <paramref name="x"/> is greater than <paramref name="y"/>.
        /// </returns>
        /// <exception cref="T:System.ArgumentException">Neither <paramref name="x"/> nor <paramref name="y"/> implements the <see cref="T:System.IComparable"/> interface.-or- <paramref name="x"/> and <paramref name="y"/> are of different types and neither one can handle comparisons with the other. </exception>
        public override int Compare(object x, object y)
        {
            if (ERP.Framework.Components.Utilities.ComparingHelper.ComapringManager.CompareTypes(x, y))
                return ((Bonus)x).Date.CompareTo(((Bonus)y).Date);
            return -1;
        }

        #endregion
    }
}
