﻿/*
 * Last review by   : Yaser
 * Last review date : JUL-21-09
 */
using System;
using System.Collections.Generic;
using ERP.Business.DataTypes.Company;

namespace ERP.Business.DataTypes.Employee.Salary
{
    /// <summary>
    /// Deduction Entry
    /// </summary>
    [System.Runtime.Serialization.DataContract]
    [Serializable]
    [System.Runtime.Serialization.KnownType(typeof(DeductionEntry))]
    public class DeductionEntry : BaseTypes.BaseType
    {
        #region Properties

        /// <summary>
        /// Gets or sets the deduction.
        /// </summary>
        /// <value>The deduction.</value>
        [System.Runtime.Serialization.DataMember]
        public Company.Deduction Deduction
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the start date.
        /// </summary>
        /// <value>The start date.</value>
        [System.Runtime.Serialization.DataMember]
        public DateTime StartDate
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the exits.
        /// </summary>
        /// <value>The exits.</value>
        [System.Runtime.Serialization.DataMember]
        public List<DeductionExitEntry> Exits
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the status.
        /// </summary>
        /// <value>The status.</value>
        [System.Runtime.Serialization.DataMember]
        public DeductionEntryStatus Status
        {
            get;
            set;
        }

        #endregion

        #region Methods

        /// <summary>
        /// Compares two objects and returns a value indicating whether one is less than, equal to, or greater than the other.
        /// </summary>
        /// <param name="x">The first object to compare.</param>
        /// <param name="y">The second object to compare.</param>
        /// <returns>
        /// A signed integer that indicates the relative values of <paramref name="x"/> and <paramref name="y"/>, as shown in the following table.Value Meaning Less than zero <paramref name="x"/> is less than <paramref name="y"/>. Zero <paramref name="x"/> equals <paramref name="y"/>. Greater than zero <paramref name="x"/> is greater than <paramref name="y"/>.
        /// </returns>
        /// <exception cref="T:System.ArgumentException">Neither <paramref name="x"/> nor <paramref name="y"/> implements the <see cref="T:System.IComparable"/> interface.-or- <paramref name="x"/> and <paramref name="y"/> are of different types and neither one can handle comparisons with the other. </exception>
        public override int Compare(object x, object y)
        {
            if (ERP.Framework.Components.Utilities.ComparingHelper.ComapringManager.CompareTypes(x, y))
                return ((DeductionEntry)x).Deduction.CompareTo(((DeductionEntry)y).Deduction);
            return -1;
        }

        #endregion
    }
}
