/*
 * Last review by   : Yaser
 * Last review date : JUL-25-09 
 */
using System.Collections;

namespace ERP.Framework.Components.DatabaseHelper
{
    /// <summary>
    /// Collection of parameters
    /// </summary>
    public class ParametersCollection
    {
        #region Members

        private ArrayList _parameters = new ArrayList();

        #endregion

        #region Properties

        /// <summary>
        /// Gets the parameters.
        /// </summary>
        /// <value>The parameters.</value>
        public ArrayList Parameters
        {
            get { return _parameters; }
        }

        #endregion

        #region Add Parameter

        /// <summary>
        /// Adds the parameter.
        /// </summary>
        /// <param name="parameterName">Name of the parameter.</param>
        /// <param name="value">The value.</param>
        /// <param name="type">The type.</param>
        /// <param name="direction">The direction.</param>
        public void AddParameter(string parameterName, object value, ParameterType type, ParameterDirection direction)
        {
            AddParameter(new Parameter(parameterName, value, type, direction));
        }

        /// <summary>
        /// Adds the parameter.
        /// </summary>
        /// <param name="parameter">The parameter.</param>
        public void AddParameter(Parameter parameter)
        {
            _parameters.Add(parameter);
        }

        #endregion

    }
}
