﻿using ERP.Framework.Components.Utilities;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using ERP.Framework.Components.Testing.SerializationHelper.Test;
namespace ERP.Framework.Components.Testing.TypeFactory.Test
{
    
    
    /// <summary>
    ///This is a test class for TypeFactoryTest and is intended
    ///to contain all TypeFactoryTest Unit Tests
    ///</summary>
    [TestClass()]
    public class TypeFactoryTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for CreateInstance
        ///</summary>
        [TestMethod()]
        public void CreateInstanceTest()
        {
            string typeName = "ERP.Framework.Components.Testing.SerializationHelper.Test.SerializingTestObject, ERP.Framework.Components.Testing";
            object actual;
            actual = Utilities.TypeHelper.TypeFactory.CreateInstance(typeName);
            Assert.AreEqual(typeof(SerializingTestObject), actual.GetType());

            typeName = typeof(SerializingTestObject).AssemblyQualifiedName;
            actual = Utilities.TypeHelper.TypeFactory.CreateInstance(typeName);
            Assert.AreEqual(typeof(SerializingTestObject), actual.GetType());
        }

        /// <summary>
        ///A test for CreateInstance
        ///</summary>
        [TestMethod()]
        public void CreateInstanceWithParameterTest()
        {
            string typeName = "ERP.Framework.Components.Testing.SerializationHelper.Test.SerializingTestObject, ERP.Framework.Components.Testing";
            object actual;
            string nameParam = "dumpData";
            actual = Utilities.TypeHelper.TypeFactory.CreateInstance(typeName, new object[]{nameParam});
            Assert.AreEqual(typeof(ERP.Framework.Components.Testing.SerializationHelper.Test.SerializingTestObject), actual.GetType());
            Assert.AreEqual(((ERP.Framework.Components.Testing.SerializationHelper.Test.SerializingTestObject)actual).Name, nameParam);
        }
    }
}